<?php
namespace Importacao\Logic\Bases\ModeloImportacao\References;

use \Importacao\Logic\Bases\ModeloImportacao\References\Reference;

class Executavel implements Reference
{

	const PADRAO_EXECUTAVEL = "/\@(.*)\@/";

	public function getRegularExpression()
	{
		return self::PADRAO_EXECUTAVEL;
	}

	public function getValorReferencia($nomeTabela, $nomeColuna, $metaDado, $valorFixo,
									   $entityContainer, $linhaDados = null, $fixedFields = null)
	{
		$dadoColuna = $this->executaMetodo($metaDado, $valorFixo, $entityContainer);
		return preg_replace(self::PADRAO_EXECUTAVEL, $dadoColuna, $metaDado);
	}

	private function executaMetodo($codigo, $placeholder, $entityContainer)
	{
		preg_match(self::PADRAO_EXECUTAVEL, $codigo, $result);
		$codigo = str_replace("@", "", $result[0]);

		if (strpos($codigo, ";") === false) {
			$codigo = $codigo.";";
		}

        eval ('$result = ' . $codigo);
		return is_callable($result) ? $result() : $result;
	}

}